config/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path
from django.views import defaults as default_views
from django.views.generic import TemplateView
from drf_spectacular.views import SpectacularAPIView, SpectacularSwaggerView
from rest_framework.authtoken.views import obtain_auth_token

urlpatterns = [
    path("", TemplateView.as_view(template_name="pages/home.html"), name="home"),
    path(
        "about/", TemplateView.as_view(template_name="pages/about.html"), name="about"
    ),
    # Django Admin, use {% url 'admin:index' %}
    path(settings.ADMIN_URL, admin.site.urls),
    # Languages selections
    path("i18n/", include("django.conf.urls.i18n")),
    # Audit log and activity stream
    path("activity/", include("actstream.urls")),
    # User management
    path("users/", include("diesos.users.urls", namespace="users")),
    path("accounts/", include("allauth.urls")),
    # Diesos Apps
    path("artefacts/", include("diesos.artefacts.urls", namespace="artefacts")),
    path("locations/", include("diesos.locations.urls", namespace="locations")),
    path("scan/", include("diesos.barcodes.urls", namespace="barcodes")),
    path("treatments/", include("diesos.treatments.urls", namespace="treatments")),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

# API URLS
urlpatterns += [
    # API base url
    path("api/", include("config.api_router")),
    # DRF auth token
    path("auth-token/", obtain_auth_token),
    path("api/schema/", SpectacularAPIView.as_view(), name="api-schema"),
    path(
        "api/docs/",
        SpectacularSwaggerView.as_view(url_name="api-schema"),
        name="api-docs",
    ),
]

if settings.DEBUG:
    # This allows the error pages to be debugged during development, just visit
    # these url in browser to see how these error pages look like.
    urlpatterns += [
        path(
            "400/",
            default_views.bad_request,
            kwargs={"exception": Exception("Bad Request!")},
        ),
        path(
            "403/",
            default_views.permission_denied,
            kwargs={"exception": Exception("Permission Denied")},
        ),
        path(
            "404/",
            default_views.page_not_found,
            kwargs={"exception": Exception("Page not Found")},
        ),
        path("500/", default_views.server_error),
    ]
    if "debug_toolbar" in settings.INSTALLED_APPS:
        import debug_toolbar

        urlpatterns = [path("__debug__/", include(debug_toolbar.urls))] + urlpatterns

diesos/artefacts/urls.py
from django.urls import path

from diesos.artefacts import views

app_name = "artefacts"

urlpatterns = [
    path("", views.ArtefactListView.as_view(), name="list"),
    path("add", views.ArtefactCreateView.as_view(), name="add"),
    path("<int:pk>/change", views.ArtefactUpdateView.as_view(), name="change"),
    path("<int:pk>/delete", views.ArtefactDeleteView.as_view(), name="delete"),
    path("<int:pk>", views.ArtefactDetailView.as_view(), name="view"),
    path("<int:pk>/scan", views.ArtefactScanView.as_view(), name="scan"),
    path(
        "<int:pk>/scan/finish",
        views.finish_stabilization_measures,
        name="finish-stabilization",
    ),
    path(
        "<int:pk>/scan/start/<int:processing_line_id>",
        views.start_stabilization_measures,
        name="start-stabilization",
    ),
    path("type", views.ArtefactTypeListView.as_view(), name="list-type"),
    path("type/add", views.ArtefactTypeCreateView.as_view(), name="add-type"),
    path(
        "type/<int:pk>/change",
        views.ArtefactTypeUpdateView.as_view(),
        name="change-type",
    ),
    path(
        "type/<int:pk>/delete",
        views.ArtefactTypeDeleteView.as_view(),
        name="delete-type",
    ),
    path(
        "type/<int:pk>/undelete",
        views.undelete_artefact_type,
        name="undelete-type",
    ),
    path("type/save-type-ordering", views.save_new_ordering, name="save-type-ordering"),
    path(
        "<int:pk>/take-picture",
        views.ArtefactTakePicture.as_view(),
        name="take-picture",
    ),
    path("damage/group", views.DamageGroupListView.as_view(), name="list-damage-group"),
    path(
        "damage/group/add",
        views.DamageGroupCreateView.as_view(),
        name="add-damage-group",
    ),
    path(
        "damage/group/<int:pk>/delete",
        views.DamageGroupDeleteView.as_view(),
        name="delete-damage-group",
    ),
    path(
        "damage/group/<int:pk>/undelete",
        views.undelete_damage_group,
        name="undelete-damage-group",
    ),
    path(
        "damage/group/<int:pk>/change",
        views.DamageGroupUpdateView.as_view(),
        name="change-damage-group",
    ),
    path("damage/type", views.TypeOfDamageListView.as_view(), name="list-damage-type"),
    path(
        "damage/type/add",
        views.TypeOfDamageCreateView.as_view(),
        name="add-damage-type",
    ),
    path(
        "damage/type/<int:pk>/delete",
        views.TypeOfDamageDeleteView.as_view(),
        name="delete-damage-type",
    ),
    path(
        "damage/type/<int:pk>/undelete",
        views.undelete_type_of_damage,
        name="undelete-damage-type",
    ),
    path(
        "damage/type/<int:pk>/change",
        views.TypeOfDamageUpdateView.as_view(),
        name="change-damage-type",
    ),
    path(
        "<int:pk>/damage-assessment",
        views.DamageAssessmentUpdateView.as_view(),
        name="change-damage",
    ),
    path("priority", views.PriorityLevelListView.as_view(), name="priority-level"),
    path(
        "priority/<int:pk>/change",
        views.PriorityLevelUpdateView.as_view(),
        name="change-priority",
    ),
    path(
        "<int:pk>/stabilization",
        views.StabilizationMeasureUpdateView.as_view(),
        name="change-stabilization-measure",
    ),
    path(
        "<int:pk>/stabilization/delete/<int:treatment_type_id>",
        views.delete_treatment_type,
        name="delete-treatment-type",
    ),
    path(
        "<int:pk>/stabilization/save-treatment-type-ordering",
        views.save_treatment_type_ordering,
        name="save-treatment-type-ordering",
    ),
    path(
        "existing-collection/import", views.UploadCsvView.as_view(), name="import-file"
    ),
    path(
        "existing-collection/headers/edit",
        views.FileHeaderEditView.as_view(),
        name="header-edit-existing-collection",
    ),
    path(
        "existing-collection/map",
        views.CsvMapperView.as_view(),
        name="map-existing-collection",
    ),
    path(
        "existing-collection/map/complex",
        views.ComplexMapperView.as_view(),
        name="map-complex-existing-collection",
    ),
    path(
        "existing-collection/<int:pk>",
        views.ExistingCollectionDetailView.as_view(),
        name="view-existing-collection",
    ),
    path(
        "existing-collection",
        views.ExistingCollectionListView.as_view(),
        name="list-existing-collection",
    ),
    path(
        "existing-collection/<int:pk>/delete",
        views.ExistingCollectionDeleteView.as_view(),
        name="delete-existing-collection",
    ),
    path(
        "existing-collection/add",
        views.create_existing_collection,
        name="add-existing-collection",
    ),
]

diesos/barcodes/urls.py
from django.urls import path

from diesos.barcodes.views import scan_barcode, search_barcode, set_scanner

app_name = "barcodes"
urlpatterns = [
    path("", view=scan_barcode, name="read"),
    path("search/", view=search_barcode, name="search"),
    path("set/<str:scanner>", view=set_scanner, name="set"),
]

diesos/treatments/urls.py
from django.urls import path

from diesos.treatments import views

app_name = "treatments"

urlpatterns = [
    path(
        "select-location",
        views.ProcessingLinesSelectView.as_view(),
        name="select-location",
    ),
    path(
        "select-location/<int:pk>",
        views.ProcessingLinesSelectView.as_view(),
        name="select-location-choice",
    ),
    path(
        "select-location/clear",
        views.ProcessingLinesSelectView.as_view(),
        name="select-location-clear",
    ),
    path(
        "types",
        views.TreatmentTypeListView.as_view(),
        name="list-treatment-type",
    ),
    path(
        "type/add",
        views.TreatmentTypeCreateView.as_view(),
        name="add-treatment-type",
    ),
    path(
        "type/<int:pk>",
        views.TreatmentTypeDetailView.as_view(),
        name="view-treatment-type",
    ),
    path(
        "type/<int:pk>/change",
        views.TreatmentTypeUpdateView.as_view(),
        name="change-treatment-type",
    ),
    path(
        "type/<int:pk>/delete",
        views.TreatmentTypeDeleteView.as_view(),
        name="delete-treatment-type",
    ),
    path(
        "type/<int:pk>/undelete",
        views.undelete_treatment_type,
        name="undelete-treatment-type",
    ),
    path(
        "processing-lines",
        views.ProcessingLineListView.as_view(),
        name="list-processing-line",
    ),
    path(
        "processing-line/add",
        views.ProcessingLineCreateView.as_view(),
        name="add-processing-line",
    ),
    path(
        "processing-line/<int:pk>",
        views.ProcessingLineDetailView.as_view(),
        name="view-processing-line",
    ),
    path(
        "processing-line/<int:pk>/scan",
        views.ProcessingLineScanView.as_view(),
        name="scan-processing-line",
    ),
    path(
        "processing-line/<int:pk>/change",
        views.ProcessingLineUpdateView.as_view(),
        name="change-processing-line",
    ),
    path(
        "processing-line/<int:pk>/delete",
        views.ProcessingLineDeleteView.as_view(),
        name="delete-processing-line",
    ),
    path(
        "processing-line/<int:pk>/undelete",
        views.undelete_processing_line,
        name="undelete-processing-line",
    ),
    path(
        "processing-line/<int:pk>/toggle-operation",
        views.toggle_operation_processing_line,
        name="toggle-operation-processing-line",
    ),
    path(
        "processing-line/<int:pk>/print-label",
        views.ProcessingLinePrintLabel.as_view(),
        name="print-label-processing-line",
    ),
]

diesos/users/urls.py
from django.urls import path

from diesos.users.views import user_detail_view, user_redirect_view, user_update_view

app_name = "users"
urlpatterns = [
    path("~redirect/", view=user_redirect_view, name="redirect"),
    path("~update/", view=user_update_view, name="update"),
    path("<str:username>/", view=user_detail_view, name="detail"),
]

diesos/treatments/models.py
from django.db import models
from django.urls import reverse
from django.utils.translation import gettext_lazy as _
from safedelete.models import SafeDeleteModel

from diesos.locations.models import Location
from diesos.utils.models import UniqueShortId


class TreatmentType(SafeDeleteModel):
    name = models.CharField(verbose_name=_("name"), max_length=225, unique=True)
    description = models.TextField(verbose_name=_("description"), null=True, blank=True)
    icon_class = models.CharField(
        verbose_name=_("icon"), max_length=255, null=True, blank=True
    )
    color = models.CharField(
        verbose_name=_("color"), max_length=7, null=True, blank=True
    )
    duration = models.DurationField(verbose_name=_("duration"), null=True, blank=True)

    # TODO: Add a M2M field with TypeOfDamage and a priority_order

    class Meta:
        verbose_name = _("treatment type")
        verbose_name_plural = _("treatment types")
        ordering = ["name"]

    def __str__(self):
        return f"{self.name}"

    def get_absolute_url(self):
        return reverse("treatments:view-treatment-type", kwargs={"pk": self.pk})


class ProcessingLine(SafeDeleteModel):
    name = models.CharField(verbose_name=_("name"), max_length=225)
    treatment_type = models.ForeignKey(
        TreatmentType,
        verbose_name=_("treatment type"),
        blank=True,
        null=True,
        on_delete=models.SET_NULL,
    )
    capacity = models.IntegerField(
        verbose_name=_("capacity"),
        blank=True,
        null=True,
        default=0,
        help_text=_(
            "The number of units that can be processed at the same time or 0 if there is no limit."
        ),
    )
    location = models.ForeignKey(
        Location,
        on_delete=models.SET_NULL,
        null=True,
        blank=True,
        related_name="processing_lines",
        verbose_name=_("location"),
    )
    running = models.BooleanField(
        verbose_name=_("running"),
        default=False,
        help_text=_("Set to true if the processing line is currently running."),
    )
    short_id = models.CharField(
        max_length=5, unique=True, null=True, verbose_name=_("short id")
    )

    class Meta:
        verbose_name = _("processing line")
        verbose_name_plural = _("processing lines")
        ordering = ["name"]
        permissions = (("can_run_processing_line", "Can run processing line"),)

    def __str__(self):
        return f"{self.name}"

    def start(self):
        # TODO: Add more business logic here
        self.running = True
        self.save()

    def stop(self):
        # TODO: Add more business logic here
        self.running = False
        self.save()

    def save(self, *args, **kwargs):
        super().save(*args, **kwargs)
        # Generate and store unique short id after saving
        if not self.short_id:
            unique_short_id = UniqueShortId.create_unique_short_id_instance(
                content_object=self
            )
            self.short_id = unique_short_id.short_id
            self.save()

    def get_absolute_url(self):
        return reverse("treatments:view-processing-line", kwargs={"pk": self.pk})

    def get_scan_url(self):
        return reverse("treatments:scan-processing-line", kwargs={"pk": self.pk})

diesos/locations/views.py
from django.contrib import messages
from django.contrib.auth.decorators import permission_required
from django.contrib.auth.mixins import PermissionRequiredMixin
from django.contrib.messages.views import SuccessMessageMixin
from django.shortcuts import redirect
from django.urls import reverse, reverse_lazy
from django.utils.translation import gettext_lazy as _
from django.views.generic import (
    CreateView,
    DeleteView,
    DetailView,
    ListView,
    UpdateView,
)
from treebeard.forms import movenodeform_factory

from .models import Location, LocationType


class LocationTypesListView(PermissionRequiredMixin, ListView):
    permission_required = "locations.view_locationtype"
    model = LocationType


class LocationTypeDetailView(PermissionRequiredMixin, DetailView):
    permission_required = "locations.view_locationtype"
    model = LocationType


class LocationTypeCreateView(PermissionRequiredMixin, SuccessMessageMixin, CreateView):
    permission_required = "locations.add_locationtype"
    model = LocationType
    fields = ["name", "description"]
    success_url = reverse_lazy("locations:list-types")
    success_message = _("The location type <strong>%(name)s</strong> has been created.")


class LocationTypeUpdateView(PermissionRequiredMixin, SuccessMessageMixin, UpdateView):
    permission_required = "locations.change_locationtype"
    model = LocationType
    fields = ["name", "description"]
    success_url = reverse_lazy("locations:list-types")
    success_message = _(
        "The  location type <strong>%(name)s</strong> has been updated."
    )


class LocationTypeDeleteView(PermissionRequiredMixin, DeleteView):
    permission_required = "locations.delete_locationtype"
    model = LocationType

    def get_success_url(self):
        return reverse("locations:list-types")

    def form_valid(self, form):
        response = super().form_valid(form)
        obj = self.object
        url = reverse("locations:undelete-type", kwargs={"pk": obj.pk})
        messages.add_message(
            self.request,
            messages.SUCCESS,
            _(
                f'The location type <strong>{obj.name}</strong> has been \
                    deleted. If it was a mistake, you can <a href="{url}">restore it</a>.'
            ),
        )
        return response


@permission_required("locations.delete_locationtype")
def undelete_location_type(request, pk):
    location_type = LocationType.all_objects.get(pk=pk)
    location_type.undelete()
    messages.add_message(
        request,
        messages.SUCCESS,
        _(
            f"The location type <strong>{location_type.name}</strong> has been restored."
        ),
    )
    return redirect("locations:list-types")


class LocationListView(PermissionRequiredMixin, ListView):
    permission_required = "locations.view_location"
    model = Location


class LocationDetailView(PermissionRequiredMixin, DetailView):
    permission_required = "locations.view_location"
    model = Location


class LocationCreateView(PermissionRequiredMixin, CreateView):
    permission_required = "locations.add_location"
    model = Location
    form_class = movenodeform_factory(Location)


class LocationUpdateView(PermissionRequiredMixin, UpdateView):
    permission_required = "locations.change_location"
    model = Location
    form_class = movenodeform_factory(Location)


class LocationDeleteView(PermissionRequiredMixin, DeleteView):
    permission_required = "locations.delete_location"
    model = Location


@permission_required("locations.delete_location")
def undelete_location(request, pk):
    location = Location.all_objects.get(pk=pk)
    location.undelete()
    messages.add_message(
        request,
        messages.SUCCESS,
        _(f"The location <strong>{location.name}</strong> has been restored."),
    )
    return redirect("locations:list")

diesos/templates/treatments/snippets/processingline_detail_table.html
{% load i18n %}

<table class="table table-hover">
  <thead>
    <tr>
      <th>{% translate 'status'|capfirst %}</th>
      {% if show_processing %}
        <th>{% translate 'processing line'|capfirst %}</th>
      {% endif %}
      <th>{% translate 'rescue number'|capfirst %}</th>
      <th>{% translate 'name'|capfirst %}</th>
      {% if show_type %}
        <th>{% translate 'type'|capfirst %}</th>
      {% endif %}
      <th>{% translate 'priority'|capfirst %}</th>
      <th class="w-25"></th>
    </tr>
  </thead>
  <tbody>
    {% for stabilization_measure in stabilization_measures %}
      {% with artefact=stabilization_measure.artefact %}
        <tr onclick="window.location='{{ artefact.get_absolute_url }}'">
          {% if stabilization_measure.status %}
            <td> {{ stabilization_measure.get_status_display }}</td>
          {% else %}
            <td>-</td>
          {% endif %}
          {% if show_processing %}
            {% if stabilization_measure.processing_line %}
              <td>
                <a href="{{ stabilization_measure.processing_line.get_absolute_url }}">{{ stabilization_measure.processing_line }}</a>
              </td>
            {% else %}
              <td>-</td>
            {% endif %}
          {% endif %}
          <td>
            {{ artefact.rescue_number }}
            {% if artefact.hazard %}<i class="bi {{ artefact.hazard.icon_class }} text-danger ms-2"></i>{% endif %}
            {% if artefact.composed_object %}<i class="bi {{ artefact.icon }} ms-2"></i>{% endif %}
          </td>
          <td>{{ artefact.name }}{% if artefact.inventory_number %} ({{ artefact.inventory_number }}){% endif %}</td>
          {% if show_type %}
            <td>{% if artefact.artefact_type %}{{ artefact.artefact_type }}{% endif %}</td>
          {% endif %}
          <td>{% if artefact.priority %}<span class="color-box" style="background-color:{{ artefact.priority.color }}"></span>{{ artefact.priority }}{% endif %}</td>
          <td><img src="{{ artefact.default_picture.url }}" class="img-fluid"> </td>
        </tr>
      {% endwith %}
    {% endfor %}
  </tbody>
</table>

diesos/templates/treatments/snippets/processingline_table.html
{% load i18n %}

<table class="table table-hover">
  <thead>
  <tr>
    <th>{% translate 'processing line'|capfirst %}</th>
    <th>{% translate 'treatment type'|capfirst %}</th>
    {% if not compact %}
      <th>{% translate 'capacity'|capfirst %}</th>
    {% endif %}
    <th>{% translate 'location'|capfirst %}</th>
    <th>{% translate 'operations'|capfirst %}</th>
    {% if not compact %}
      <th></th>
    {% endif %}
  </tr>
  </thead>
  <tbody>
  {% for processing_line in processing_lines %}
    <tr onclick="window.location='{{ processing_line.get_absolute_url }}'">
      <td>{{ processing_line.name }}</td>
      <td>
        {% if processing_line.treatment_type %}
          <a href="{{ processing_line.treatment_type.get_absolute_url }}">{{ processing_line.treatment_type }}</a>
        {% else %}
          {% translate 'no treatment defined'|capfirst %}
        {% endif %}
      </td>
      {% if not compact %}
        <td>
          {% if processing_line.capacity == 0 %}
            {% translate 'unlimited'|capfirst %}
          {% else %}
            {{ processing_line.capacity }}
          {% endif %}
        </td>
      {% endif %}
      <td>
        {% if processing_line.location %}
          <a href="{{ processing_line.location.get_absolute_url }}">{{ processing_line.location }}</a>
        {% else %}
          {% translate 'no location'|capfirst %}
        {% endif %}
      </td>
      <td>
        {% if processing_line.running %}<span class="text-success">{% translate 'running'|upper %}</span>
        {% else %}<span class="text-danger">{% translate 'closed'|upper %}</span>
        {% endif %}
      </td>
      {% if not compact %}
        <td class="text-end">
          {% if perms.treatments.change_processingline %}
            <a href="{% url 'treatments:change-processing-line' processing_line.id %}"
               class="btn-sm btn-outline-primary mx-1"><i class="bi bi-pencil"></i></a>
          {% endif %}
          {% if perms.treatments.delete_processingline %}
            <a href="{% url 'treatments:delete-processing-line' processing_line.id %}"
               class="btn-sm btn-outline-danger mx-1"><i class="bi bi-trash"></i></a>
          {% endif %}
        </td>
      {% endif %}
    </tr>
  {% endfor %}
  </tbody>
</table>